/*
 * $Id: BulletPoolImpl.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.dngn {
  import flash.display.BitmapData;
  import abagames.util.bulletml.BulletML;
  import abagames.util.bulletml.BulletPool;
  import abagames.util.bulletml.Bullet;
  import abagames.dngn.BulletImpl;

  /**
   * BulletPool.
   */
  public class BulletPoolImpl implements BulletPool {
    private var bullets:Array = new Array;

    public function addBullet(bml:BulletML, x:Number, y:Number, deg:Number, speed:Number):Bullet {
      var b:BulletImpl = new BulletImpl(bml, this, x, y, deg, speed);
      bullets.push(b);
      return b;
    }

    public function run(buf:BitmapData, dots:Dots = null):void {
      var b:BulletImpl;
      for each (b in bullets)
        b.run(buf, dots);
      for (var i:int = 0; i < bullets.length; ) {
        b = BulletImpl(bullets[i]);
        if (b.isEnd()) {
          bullets.splice(i, 1);
        } else {
          i++;
        }
      }
    }
  }
}
