/*
 * $Id: Bullet.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.util.bulletml {
  /**
   * Interface for a bullet controlled with BulletML.
   */
  public interface Bullet {
    function getDirection():Number;
    function setDirection(v:Number):void;
    function getAimDirection():Number;
    function getSpeed():Number;
    function setSpeed(v:Number):void;
    function getX():Number;
    function getY():Number;
    function getHorizontal():Number;
    function setHorizontal(v:Number):void;
    function getVertical():Number;
    function setVertical(v:Number):void;
    function vanish():void;
    function getRand():Number;
    function getRank():Number;
  }
}
